MODULE Editor;

TYPE
  Window = OBJECT IMPLEMENTS System.Windows.Forms.Form;

    PROCEDURE ADD(cntl: System.Windows.Forms.Control);
    BEGIN
      System.Windows.Forms.Form.get_Controls().Add(cntl);
    END ADD;

    PROCEDURE NEW();
    VAR
      size: System.Drawing.Size;
      font: System.Drawing.Font;

      Mkc_CodeBox1: mkc_CodeBox.mkc_CodeBox;

      MainMenu: System.Windows.Forms.MainMenu;
      MenuItem: ARRAY 2 OF System.Windows.Forms.MenuItem;
      MenuItem1: ARRAY 2 OF System.Windows.Forms.MenuItem;
    BEGIN
      NEW(size,640,480);
      System.Windows.Forms.Form.set_ClientSize(size);
      System.Windows.Forms.Form.set_FormBorderStyle(System.Windows.Forms.FormBorderStyle.Sizable);
      System.Windows.Forms.Form.set_MaximizeBox(FALSE);
      System.Windows.Forms.Form.set_Text("Window for Lightning Oberon");

      NEW(MainMenu);

      NEW(MenuItem[0]);
      MenuItem[0].set_Index(0);
      MenuItem[0].set_Text("File");
      MenuItem[0].set_Visible (TRUE);

      NEW(MenuItem[1]);
      MenuItem[1].set_Index(1);
      MenuItem[1].set_Text("New");
      MenuItem[1].set_Visible (TRUE);

      NEW(MenuItem1[0]);
      MenuItem1[0].set_Index(2);
      MenuItem1[0].set_Text("Open");
      MenuItem1[0].set_Visible (TRUE);
      MenuItem1[0].set_Shortcut(System.Windows.Forms.Shortcut.CtrlO);

      NEW(MenuItem1[1]);
      MenuItem1[1].set_Index(3);
      MenuItem1[1].set_Text("Exit");
      MenuItem1[1].set_Visible (TRUE);
      MenuItem1[1].set_Shortcut(System.Windows.Forms.Shortcut.CtrlX);

      MenuItem[0].get_MenuItems().AddRange(MenuItem1);

      MainMenu.get_MenuItems().AddRange(MenuItem);

      SELF.set_Menu(MainMenu);

      NEW(Mkc_CodeBox1);
      ADD(System.Windows.Forms.Control(Mkc_CodeBox1));
      (*NEW(font,"Arial",11);*)
      Mkc_CodeBox1.set_Sidebar_Font(font);

      Mkc_CodeBox1.set_BorderStyle(System.Windows.Forms.BorderStyle.None);
      Mkc_CodeBox1.set_Dock(System.Windows.Forms.DockStyle.Fill);

      Mkc_CodeBox1.set_TextEditor_ColorCode(TRUE);
      Mkc_CodeBox1.set_TextEditor_CommentCharacter("'");
      Mkc_CodeBox1.set_TextEditor_CommentTextColor(System.Drawing.Color.get_Green());

      Mkc_CodeBox1.set_TextEditor_KeywordDelimiter("|");
      Mkc_CodeBox1.set_TextEditor_KeywordList("DIV|MOD|OR|IN|OF|THEN|DO|TO|END|UNTIL|ELSE|ELSIF|IF|WHILE|REPEAT|LOOP|EXIT|RETURN|FOR|BY|ARRAY|CONST|TYPE|VAR|PROCEDURE|BEGIN|IMPORT|IMPLEMENTS|CUSTOMIZES|DEFINITION|MODULE|INTERFACE|STATIC|VIRTUAL|CASE|ACTIVE");
      Mkc_CodeBox1.set_TextEditor_KeywordTextColor(System.Drawing.Color.get_Blue());
      Mkc_CodeBox1.set_TextEditor_NormalTextColor(System.Drawing.Color.get_Black());

      Mkc_CodeBox1.LoadFile("Editor.mod", System.Windows.Forms.RichTextBoxStreamType.PlainText);
      Mkc_CodeBox1.RecolorCode();
      Mkc_CodeBox1.GoToLine(10);
    END NEW;

  END Window;

VAR
  window: Window;

BEGIN
  NEW(window);
  System.Windows.Forms.Application.Run(System.Windows.Forms.Form(window));
END Editor.
